/*********************************************************************
 *	UNIX: RS232C ̐.
 *********************************************************************

 * EI:
int		RS_init(char *portno,int baudrate);
void	RS_exit(void);

 * 菇[̎s:
void	RS_terminal(char *port_no,int baudrate);

 * f[^M:
int		RS_putdata(	unsigned char *buf , int cnt );
int		RS_putc(int c);
 * f[^M:
int		RS_checkdata();
int		RS_getdata(unsigned char *buf,int cnt);

 * L[{[h:
int		RS_keyInput(void);
 *
 *********************************************************************
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <termios.h>
#include <sys/signal.h>
#include <unistd.h>
#include <fcntl.h>

typedef unsigned char u_char;

#include "monit.h"
#include "util.h"
#include "rs232c.h"

/*********************************************************************
 *	`
 *********************************************************************
 */

#define		KEY_ESCAPE_CH	0x01

#define	MAX_RESULT_LENGTH	32		//Mobt@.

#define	RESULT_LENGTH_MASK	0x7f	//M̗L}XNrbg.
#define	TXBUF_FULL_MASK		0x80	//Mobt@trbg.

#define	RS_EMPTY			(-9)

#define	BENCH_LENGTH		450		//x`}[N: PsM̒.
#define	BENCH_COUNT			250		//x`}[N: PsM̉.

#define	PACKET_DUMP			0		//fobOp.

/*********************************************************************
 *	O[o
 *********************************************************************
 */
static char	COM_Device[256];

int COM_fd;
struct termios oldtio;  /* current TTY settings */
struct termios oldstio; /* current serial port settings  */
int tty_fd = -1;

//void	Term_Log(int c);
//usb_dev_handle *usb_dev; /* the device handle */
//extern char *upfile;	//Abv[ht@C.
FILE   *upload_fp=NULL;
int		opt_d;


/*********************************************************************
 *	qrQRQb f[^ o.
 *********************************************************************
 */
int	RS_putdata(	unsigned char *buf , int cnt )
{
	int result = write(COM_fd, buf, cnt);
	return result;
}

/*********************************************************************
 *	qrQRQbo.
 *********************************************************************
 */
int	RS_putc(int c)
{
	unsigned char buf[2];
	buf[0] = c;
	if (RS_putdata(buf, 1) == 1)
		return 0;
	else return -1;
}

int	RS_puts(u_char *buf, int len)
{
	RS_putdata(buf,len);
	return 0;
}

int fd_available(int fd)
{
	struct timeval tv;
	int n;
	fd_set fds;
	tv.tv_sec = 0;
	tv.tv_usec = 0;
	FD_ZERO(&fds);
	FD_SET(fd, &fds);
	n = select(fd + 1, &fds, NULL, NULL, &tv);
	if (n > 0 && FD_ISSET(COM_fd, &fds))
		return 1;
	else return 0;
}

/*********************************************************************
 *	R\[
 *********************************************************************
 */
void RS_restoreTTYsettings(void)
{
	if (tty_fd >= 0) {
		tcsetattr(tty_fd, 0, &oldtio);
		close(tty_fd);
	}
}

int	RS_keyInput(void)
{
	if (tty_fd < 0) {
		struct termios rawtio;
		tty_fd = open("/dev/tty", O_RDONLY);
		if (tty_fd < 0) {
			fprintf(stderr, "Cannot open /dev/tty\n");
			exit(1);
		}
		tcgetattr(tty_fd, &oldtio);
		rawtio = oldtio;
		cfmakeraw(&rawtio);
		rawtio.c_cc[VMIN] = 1;
		rawtio.c_cc[VTIME] = 0;
		tcsetattr(tty_fd, 0, &rawtio);
		fcntl(tty_fd, F_SETFL, O_NONBLOCK);
		atexit(RS_restoreTTYsettings);
	}
	if (fd_available(tty_fd)) {
		unsigned char c;
		read(tty_fd, &c, 1);
		return c;
	}
	return 0;
}

int RS_keyavailable(void)
{
	if (tty_fd >= 0)
		return fd_available(tty_fd);
	else return 0;
}

/*********************************************************************
 *	t@CAbv[h@\܂ރR\[
 *********************************************************************
 */
int	RS_keyInputUP(void)
{
	if(upload_fp) {	//Abv[h.
		int c = fgetc(upload_fp);	//t@C當擾.
		if(c != EOF) {
			return c;
		}
		fclose(upload_fp);
		upload_fp = NULL;
	}
	return RS_keyInput();
}

void rs_dump(unsigned char *buf,int cnt)
{
#if	PACKET_DUMP
	memdump("RD", buf, cnt);
#endif
}
/*********************************************************************
 *	COMMfoCXPoCgM.
 *********************************************************************
 *	߂l:
 *		0 MȂ.
 *		1 Mnj.
 *
 *
 */
int	RS_getdata(unsigned char *buf, int cnt)
{
	unsigned char c;
	int res, n;
	res = 0;
	do {
		n = read(COM_fd, buf + res, cnt - res);
		res += n;
	} while (res < cnt);
	if (res == cnt) {
		rs_dump(buf, cnt);
		return cnt;
	} else {
		extern int verbose;
		if (verbose > 0)
			fprintf(stderr, "RS_getdata failed (%d < %d)\n", res, cnt);
		return 0;
	}
}
/*********************************************************************
 *	
 *********************************************************************
 */
int	RS_checkdata()
{
	return fd_available(COM_fd);
}

/*********************************************************************
 *	
 *********************************************************************
 */
int	RS_getc()
{
	int c;
	unsigned char buf[16];

	if(RS_checkdata()) {
		RS_getdata(buf, 1);
		c = buf[0];
		return (c & 0xff);
	}
	return RS_EMPTY;	// Empty
}

/*********************************************************************
 *	bnl|[g̏
 *********************************************************************
 */
int	RS_init(char *port_no, int baudrate)
{
	struct termios tio;
	COM_fd = open(port_no, O_RDWR | O_NOCTTY);
	if (COM_fd < 0) {
		fprintf(stderr, "Cannot open COM port %s\n", port_no);
		exit(1);
	}
	tcgetattr(COM_fd, &tio);
	oldstio = tio;
	switch (baudrate) {
		case 0: baudrate = B0; break;
		case 50: baudrate = B50; break;
		case 75: baudrate = B75; break;
		case 110: baudrate = B110; break;
		case 134: baudrate = B134; break;
		case 150: baudrate = B150; break;
		case 200: baudrate = B200; break;
		case 300: baudrate = B300; break;
		case 600: baudrate = B600; break;
		case 1200: baudrate = B1200; break;
		case 1800: baudrate = B1800; break;
		case 2400: baudrate = B2400; break;
		case 4800: baudrate = B4800; break;
		case 9600: baudrate = B9600; break;
		case 19200: baudrate = B19200; break;
		case 38400: baudrate = B38400; break;
		case 57600: baudrate = B57600; break;
		case 115200: baudrate = B115200; break;
		case 230400: baudrate = B230400; break;
		default:
			fprintf(stderr, "Cannot set baudrate to %d\n", baudrate);
			exit(1);
	}
	cfsetspeed(&tio, baudrate);
	tcsetattr(COM_fd, 0, &tio);
	return 0;
}

/*********************************************************************
 *
 *********************************************************************
 */

void RS_exit(void)
{
	tcsetattr(COM_fd, 0, &oldstio);
	close(COM_fd);
}
/*********************************************************************
 *	GR[obNET[o[.
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_echohost(char *port_no,int baudrate)
{
	int c;
	unsigned char buf[16];
	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	printf("Entering EchobackMode: Escape=^%c\n", '@' +	KEY_ESCAPE_CH );

	while(1) {
		c = RS_keyInput();if(c == KEY_ESCAPE_CH) break;	//Eo.
		if(	RS_checkdata() ) {
			RS_getdata(buf,1);
			c = buf[0];
			RS_putc(c);
			putchar(c);
			if(c == '\r') {
				c = '\n';
				RS_putc(c);
				putchar(c);
			}
		}
	}
	RS_exit();
}

void bench_tx()
{
	int i,c=' ';
	
#if	0
	for(i=0;i<BENCH_LENGTH;i++,c++) {
		RS_putc(c);
	}
#else
	u_char buf[BENCH_LENGTH+16];
	for(i=0;i<BENCH_LENGTH;i++,c++) {
		buf[i]=c;
	}
	RS_puts(buf,BENCH_LENGTH);
//	printf("Send data=\n");
//	memdump(buf,BENCH_LENGTH,0);
#endif
}

int bench_rx(void)
{
	int i,c=' ',r,errs=0;
	u_char buf[BENCH_LENGTH+1024];
	memset(buf,0,BENCH_LENGTH+1024);
	
	for(i=0;i<BENCH_LENGTH;i++,c++) {
		do {
			r = RS_getc();
		}while (r == RS_EMPTY);

		buf[i]=r;
		//memdump(buf+i,1,0);
		if(opt_d) {
			printf(" %02x",r);
		}

		if(r != (c & 0xff) ) {
			errs++;
		}
	}
	if(errs) {
		printf("Recv Error = %2d:\n", errs);
		memdump_print((char*)buf,BENCH_LENGTH,0);
	}

	if(opt_d) {
		printf("\n");
	}

	return errs;
}

/*********************************************************************
 *	
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_benchmark(char *port_no,int baudrate)
{
	int c,i;
	int count=BENCH_COUNT;
	int time1, rate;
	int total;

	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	printf("Entering Benchmark: Escape=^%c\n", '@' + KEY_ESCAPE_CH );
	int time0 = clock();

	bench_tx();
	for(i=0;i<count;i++) {
		bench_tx();
		c = RS_keyInput();if(c == KEY_ESCAPE_CH) break;	//Eo.
		bench_rx();
		putchar('.');
		fflush(stdout);
	}
	bench_rx();
	
	printf("\nBenchmark end. ");
	time1 = clock() - time0;
	if (time1 == 0) {
		time1 = 2;
	}
	total = count * BENCH_LENGTH;
	rate = total * 1000 / time1;
   	printf("%d bytes/%d ms,  %d bytes/s (%d bps)\n",total,time1,rate,rate*10);

	RS_exit();
}
/*********************************************************************
 *	"COMXX:" |[g̃vpeB.
 *********************************************************************
 */
void RS_printCommInfo(char *comXX)
{
	fprintf(stderr, "printCommInfo: not supported yet\n");
}
/*********************************************************************
 *	WIN32: WXgāAobɑ݂COM Port񋓂Ă݂.
 *********************************************************************
 */
int RS_printinfo(int baudrate)
{
	fprintf(stderr, "printInfo: not supported\n");
	return 0;
}



/*********************************************************************
 *	
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_terminal(char *port_no,int baudrate)
{
	int c;
	unsigned char buf[16];

//	if( upfile != NULL) {
//		upload_fp = fopen(upfile,"rb");
//	}

	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	printf("Entering TerminalMode: Escape=^%c\n", '@' +	KEY_ESCAPE_CH );
	signal(SIGINT, SIG_IGN);	// ^C 𖳌ɂ.

	while(1) {
		c = RS_keyInputUP();
		if(c) {
			if(c == KEY_ESCAPE_CH) break;	//Eo.
			RS_putc(c);
		}
		if(	RS_checkdata() ) {
			RS_getdata(buf,1);
//			Term_Log(buf[0]);
			putchar(buf[0]);
		}
	}
	signal(SIGINT, SIG_DFL);
	RS_exit();
}
/*********************************************************************
 *
 *********************************************************************
 */

