/****************************************************************************
 *	usb to uart interface conversion
 ****************************************************************************
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
/*
#include <windows.h>
#include <setupapi.h>
#include <dbt.h>
*/

#include  "rs232c.h"
#include  "util.h"
#include  "usb-uart.h"

extern int verbose;

int	usbOpen(int vendorID,int productID)
{
	return 0;
}

int	usbWrite(uchar *usbBuf,int len,uchar *readBuf,int readlen)
{
	if(len) {
		if (verbose > 0) {
			int i;
			fprintf(stderr, "usbWrite: sending buffer [");
			for (i = 0; i < len && i < 8; i++) {
				fprintf(stderr, "0x%02x", usbBuf[i]);
				if (i + 1 < len && i < 7)
					fputc(' ', stderr);
				else {
					if (i < len - 1)
						fputs("...", stderr);
				}
			}
			fputs("]\n", stderr);
		}
		uchar buf[256];
		memcpy(buf+1,usbBuf,len);
		buf[0]=0x01;
		RS_putdata(buf,len+1);
	}

	if(readlen) {
		if (verbose > 0)
			fprintf(stderr, "usbWrite: reading %d bytes...\n", readlen);
		RS_getdata(readBuf,readlen);
		if (verbose > 0)
			fprintf(stderr, "Done.\n");
	}
	return 0;	// Ok.
}


void usbClose(void)
{
}
